require "cuba"
require "securerandom"

module Cuba::CSRF
  def csrf_safe?
    req.get? || req.head? ||
      req[:csrf_token] == csrf_token ||
      env["HTTP_X_CSRF_TOKEN"] == csrf_token
  end

  def csrf_token
    session[:csrf_token] ||= SecureRandom.base64(32)
  end

  def csrf_form_tag
    %Q(<input type="hidden" name="csrf_token" value="#{csrf_token}">)
  end
  alias :csrf_tag :csrf_form_tag

  def csrf_meta_tag
    %Q(<meta name="csrf_token" content="#{csrf_token}">)
  end
end
